<?php

include(dirname(__FILE__).'/../../config/config.inc.php');
include(dirname(__FILE__).'/dotpay.php');

	$errors = '';
	$dotpay = new Dotpay();


	if(!isset($_POST['id']) ||				// md5
		!isset($_POST['status']) ||			
		!isset($_POST['control']) ||		// md5
		!isset($_POST['t_id']) ||			// md5
		!isset($_POST['amount']) ||			// md5
		!isset($_POST['email']) ||	
		!isset($_POST['t_status']) ||		// md5
		!isset($_POST['md5'])) {
		die('ERROR: MISSING PARAMETERS'); //-- brak wszystkich parametrow
	}
	if ($_POST['id'] != Configuration::get('DOTPAY_ID')){
		die('ERROR: WRONG ID');   //--- bledny ID
	}

	$sig = md5(Configuration::get('DOTPAY_PIN').':'.
				$_POST['id'].':'.
				$_POST['control'].':'.
				$_POST['t_id'].':'.
				$_POST['amount'].':'.
				$_POST['email'].
				':::::'.
				$_POST['t_status']);
	if ($_POST['md5'] != $sig){
		die('ERROR: WRONG SIGNATURE');   //--- bledny podpis
	}


	switch (intval($_POST['t_status'])) {
		case 1:  // Nowa
			$trans_state = Configuration::get('PAYMENT_NEW_STATE');
			break;
		case 2:  // Wykonana
			$trans_state = _PS_OS_PAYMENT_;
			break;
		case 3:  // Odmowna
			$trans_state = _PS_OS_ERROR_;
			break;
		case 4:  // Anulowana
			$trans_state = _PS_OS_CANCELED_;
			break;
		case 5:  // Reklamacja
			$trans_state = _PS_OS_ERROR_;
			break;
		default:
			die('OK');
	}
	
	$cart = new Cart(intval($_POST['control']));
	if (!$cart->id){
		$errors = $dotpay->l('Nie znaleziono koszyka').'<br />';
	} elseif (!Order::getOrderByCartId($_POST['control'])){
		$cart = new Cart($_POST['control']);
		define('_USER_ID_LANG_', intval($cart->id_lang));
		$cart = null;
		$dotpay->validateOrder($_POST['control'], $trans_state, $_POST['amount'], $dotpay->displayName, 'Dotpay ID transkacji: '.$_POST['t_id']);
	}else{
		$order_id = Order::getOrderByCartId($_POST['control']);
		$history = new OrderHistory();
		$history->id_order = intval($order_id);
		$history->changeIdOrderState($trans_state, intval($order_id));
		$history->addWithemail(true);				
	}
	if (!empty($errors))
		die('ERROR: PROBLEMS WITH PROCESSING PAYMENT: '.$errors);
	echo 'OK';

?>